;  :
; http://www.autohotkey.com/docs/KeyList.htm
; http://www.autohotkey.com/docs/commands/ControlSend.htm
; http://www.autohotkey.com/docs/commands/Send.htm
; http://www.autohotkey.com/docs/scripts/JoystickTest.htm
;  ControlSend      ,      .
; ,       - "mousetokey",
;     - xpadder'       
; ,   .
;
;         -     
;  .        .  , , 
; .

#Persistent
#InstallKeybdHook ;     ,    VK   

SetTimer, WatchPOV, 10 ;  10    WatchPOV, WatchAXE2Y  WATCHAXE2X
SetTimer, WatchAXE2Y, 10
SetTimer, WatchAXE2X, 10
return

WatchPOV: ;     
	WinGet, L, list, decay ; -   .    "decay"
	If L<2 ;       
{
	ExitApp ; 
}
	WinGet, PID2, PID, ahk_id %L2% ;  PID   2 (..    !)
	GetKeyState, POV, JoyPOV ;        
	KeyToHoldDownPrev = %KeyToHoldDown%
	if POV < 0
;	ControlSend, , {Up up}{a up}{Down up}{d up} , ahk_pid %PID2%
	KeyToHoldDown =
	else if POV = 0
{
	ControlSend, , {Up down}{a up}{Down up}{d up} , ahk_pid %PID2%
	KeyToHoldDown = Up
}
	else if POV = 4500
{
	ControlSend, , {Up down}{a up}{Down up}{d down} , ahk_pid %PID2%
	KeyToHoldDown = UpRight
}
	else if POV = 9000
{
	ControlSend, , {Up up}{a up}{Down up}{d down} , ahk_pid %PID2%
	KeyToHoldDown = Right
}
	else if POV = 13500
{
	ControlSend, , {Up up}{a up}{Down down}{d down} , ahk_pid %PID2%
	KeyToHoldDown = RightDown
}
	else if POV = 18000
{
	ControlSend, , {Up up}{a up}{Down down}{d up} , ahk_pid %PID2%
	KeyToHoldDown = Down
}
	else if POV = 22500
{
	ControlSend, , {Up up}{a down}{Down down}{d up} , ahk_pid %PID2%
	KeyToHoldDown = DownLeft
}
	else if POV = 27000
{
	ControlSend, , {Up up}{a down}{Down up}{d up} , ahk_pid %PID2%
	KeyToHoldDown = Left
}
	else if POV = 31500
{
	ControlSend, , {Up down}{a down}{Down up}{d up} , ahk_pid %PID2%
	KeyToHoldDown = LeftUp
}

if KeyToHoldDown = %KeyToHoldDownPrev%  ;      -    -   {"" up}
	return
	ControlSend, , {Up up}{a up}{Down up}{d up} , ahk_pid %PID2%
return



WatchAxe2Y: ; ,    Y    
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	GetKeyState, joyr, JoyR ;     Y    AutoHotKey'  R
	AxisRHoldPrev = %AxisRHold%
	if ((joyr > 41) && (joyr < 59))
	AxisRHold =
	else if joyr > 60
{
	ControlSend, , {k down}{i up} , ahk_pid %PID2%
	AxisRHold = k
}
	else if joyr < 40
{
	ControlSend, , {k up}{i down} , ahk_pid %PID2%
	AxisRHold = i
}
 
if AxisRHold = %AxisRHoldPrev%
	return
	ControlSend, , {k up}{i up} , ahk_pid %PID2%
return



WatchAxe2X: ; ,    X    
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	GetKeyState, joyz, JoyZ ;     X    AutoHotKey'  Z
	AxisZHoldPrev = %AxisZHold%
	if ((joyz > 41) && (joyz < 59))
	AxisZHold =
	else if joyz > 60
{
	ControlSend, , {l down}{j up} , ahk_pid %PID2%
	AxisZHold = l
}
	else if joyz < 40
{
	ControlSend, , {l up}{j down} , ahk_pid %PID2%
	AxisZHold = j
}

if AxisZHold = %AxisZHoldPrev%  ; The correct key is already down (or no key is needed).
	return
	ControlSend, , {l up}{j up} , ahk_pid %PID2%
return

;          

Joy1::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {LShift down} , ahk_pid %PID2%
	SetTimer, WaitForButton1, 10 ;      
return

WaitForButton1:
	if GetKeyState("Joy1")
	return
	ControlSend, , {LShift up} , ahk_pid %PID2%
	SetTimer, WaitForButton1, off
return


Joy2::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {r} , ahk_pid %PID2%
return

Joy3::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {y down} , ahk_pid %PID2%
	SetTimer, WaitForButton3, 10
return

WaitForButton3:
	if GetKeyState("Joy3")
	return
	ControlSend, , {y up} , ahk_pid %PID2%
	SetTimer, WaitForButton3, off
return


Joy4::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {h down} , ahk_pid %PID2%
	SetTimer, WaitForButton4, 10
return

WaitForButton4:
	if GetKeyState("Joy4")
	return
	ControlSend, , {h up} , ahk_pid %PID2%
	SetTimer, WaitForButton4, off
return


Joy5::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {VKDB} , ahk_pid %PID2% ;  VKDB (  DB)    [
return


Joy6::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {VKDD} , ahk_pid %PID2% ; DD  ]
return


Joy7::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {LCtrl down} , ahk_pid %PID2%
	SetTimer, WaitForButton7, 10
return

WaitForButton7:
	if GetKeyState("Joy7")
	return
	ControlSend, , {LCtrl up} , ahk_pid %PID2%
	SetTimer, WaitForButton7, off
return


Joy8::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {Space} , ahk_pid %PID2% ;        SetTimer 
return


;Joy9::     -----        Escape,  -   
;    
;	WinGet, L, list, decay
;	If L<2
;{
;	ExitApp
;}
;	WinGet, PID2, PID, ahk_id %L2%
;	ControlSend, , {Escape} , ahk_pid %PID2%
return

Joy10::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {e} , ahk_pid %PID2%
return


Joy11::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {f} , ahk_pid %PID2%
return


Joy12::
	WinGet, L, list, decay
	If L<2
{
	ExitApp
}
	WinGet, PID2, PID, ahk_id %L2%
	ControlSend, , {End} , ahk_pid %PID2%
return